/*----- PROTECTED REGION ID(Lakeshore_336.cpp) ENABLED START -----*/
//=============================================================================
//
// file :        Lakeshore_336.cpp
//
// description : C++ source for the Lakeshore_336 and its commands.
//               The class is derived from Device. It represents the
//               CORBA servant object which will be accessed from the
//               network. All commands which can be executed on the
//               Lakeshore_336 are implemented in this file.
//
// project :     Lakeshore_336.
//
// $Author: alessio $
//
// $Revision: 1.1.1.1 $
// $Date: 2014-02-25 10:01:39 $
//
// SVN only:
// $HeadURL:  $
//
// CVS only:
// $Source: /home/cvsadm/cvsroot/fermi/servers/336/src/Lakeshore_336.cpp,v $
// $Log: Lakeshore_336.cpp,v $
// Revision 1.1.1.1  2014-02-25 10:01:39  alessio
// Initial import
//
// Revision 1.2  2013-05-30 13:29:00  alessio
// Move to Tango8 and remove all build warnings
//
// Revision 1.1.1.1  2012-11-27 10:07:31  alessio
// Initial import
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#include <Lakeshore_336.h>
#include <Lakeshore_336Class.h>

/*----- PROTECTED REGION END -----*/


/**
 *	Lakeshore_336 class description:
 *	basic interface for the Lakeshore Model 336 Temperature controller,
 *	GPIB/Ethernet interface.
 *	reads 4 temperatures, outputs, alarms.
 */

//================================================================
//
//  The following table gives the correspondence
//  between command and method names.
//
//  Command name  |  Method name
//----------------------------------------------------------------
//  State         |  dev_state
//  Status        |  dev_status
//================================================================

namespace Lakeshore_336_ns
{
	/*----- PROTECTED REGION ID(Lakeshore_336::namespace_starting) ENABLED START -----*/

	//	static initializations

	/*----- PROTECTED REGION END -----*/	//	Lakeshore_336::namespace_starting



//--------------------------------------------------------
/**
 *	Method      : Lakeshore_336::Lakeshore_336()
 *	Description : Constructors for a Tango device
 *	              implementing the class Lakeshore_336
 */
//--------------------------------------------------------
Lakeshore_336::Lakeshore_336(Tango::DeviceClass *cl, string &s)
 	: Tango::Device_4Impl(cl, s.c_str())
{
	/*----- PROTECTED REGION ID(Lakeshore_336::constructor_1) ENABLED START -----*/

	init_device();

	/*----- PROTECTED REGION END -----*/	//	Lakeshore_336::constructor_1
}
//--------------------------------------------------------
Lakeshore_336::Lakeshore_336(Tango::DeviceClass *cl, const char *s)
 	: Tango::Device_4Impl(cl, s)
{
	/*----- PROTECTED REGION ID(Lakeshore_336::constructor_2) ENABLED START -----*/

	init_device();

	/*----- PROTECTED REGION END -----*/	//	Lakeshore_336::constructor_2
}
//--------------------------------------------------------
Lakeshore_336::Lakeshore_336(Tango::DeviceClass *cl, const char *s, const char *d)
 	: Tango::Device_4Impl(cl, s, d)
{
	/*----- PROTECTED REGION ID(Lakeshore_336::constructor_3) ENABLED START -----*/

	init_device();

	/*----- PROTECTED REGION END -----*/	//	Lakeshore_336::constructor_3
}


//--------------------------------------------------------
/**
 *	Method      : Lakeshore_336::delete_device()()
 *	Description : will be called at device destruction or at init command
 */
//--------------------------------------------------------
void Lakeshore_336::delete_device()
{
	/*----- PROTECTED REGION ID(Lakeshore_336::delete_device) ENABLED START -----*/

	//	Delete device allocated objects
	delete socket;

	/*----- PROTECTED REGION END -----*/	//	Lakeshore_336::delete_device
	delete[] attr_SetP_read;
	delete[] attr_Heater_read;
	delete[] attr_PidProportional_read;
	delete[] attr_PidIntegral_read;
	delete[] attr_PidDerivative_read;
	
}


//--------------------------------------------------------
/**
 *	Method      : Lakeshore_336::init_device()
 *	Description : //	will be called at device initialization.
 */
//--------------------------------------------------------
void Lakeshore_336::init_device()
{
	DEBUG_STREAM << "Lakeshore_336::init_device() create device " << device_name << endl;

	/*----- PROTECTED REGION ID(Lakeshore_336::init_device_before) ENABLED START -----*/

	//	Initialization before get_device_property() call

	/*----- PROTECTED REGION END -----*/	//	Lakeshore_336::init_device_before
	
	//	Get the device properties (if any) from database
	get_device_property();
	
	attr_SetP_read = new Tango::DevDouble[1];
	attr_Heater_read = new Tango::DevFloat[1];
	attr_PidProportional_read = new Tango::DevFloat[1];
	attr_PidIntegral_read = new Tango::DevFloat[1];
	attr_PidDerivative_read = new Tango::DevUChar[1];
	
	/*----- PROTECTED REGION ID(Lakeshore_336::init_device) ENABLED START -----*/

	//	Initialize device
	// connect to the socket device
	socket = new Tango::DeviceProxy(socketDeviceProxy);

	/*----- PROTECTED REGION END -----*/	//	Lakeshore_336::init_device
}



//--------------------------------------------------------
/**
 *	Method      : Lakeshore_336::get_device_property()
 *	Description : //	Add your own code to initialize
 */
//--------------------------------------------------------
void Lakeshore_336::get_device_property()
{
	/*----- PROTECTED REGION ID(Lakeshore_336::get_device_property_before) ENABLED START -----*/

	//	Initialize property data members

	/*----- PROTECTED REGION END -----*/	//	Lakeshore_336::get_device_property_before


	//	Read device properties from database.
	Tango::DbData	dev_prop;
	dev_prop.push_back(Tango::DbDatum("SocketDeviceProxy"));

	//	is there at least one property to be read ?
	if (dev_prop.size()>0)
	{
		//	Call database and extract values
		if (Tango::Util::instance()->_UseDb==true)
			get_db_device()->get_property(dev_prop);
	
		//	get instance on Lakeshore_336Class to get class property
		Tango::DbDatum	def_prop, cl_prop;
		Lakeshore_336Class	*ds_class =
			(static_cast<Lakeshore_336Class *>(get_device_class()));
		int	i = -1;

		//	Try to initialize SocketDeviceProxy from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  socketDeviceProxy;
		else {
			//	Try to initialize SocketDeviceProxy from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  socketDeviceProxy;
		}
		//	And try to extract SocketDeviceProxy value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  socketDeviceProxy;


	}
	/*----- PROTECTED REGION ID(Lakeshore_336::get_device_property_after) ENABLED START -----*/

	//	Check device property data members init

	/*----- PROTECTED REGION END -----*/	//	Lakeshore_336::get_device_property_after

}

//--------------------------------------------------------
/**
 *	Method      : Lakeshore_336::always_executed_hook()
 *	Description : method always executed before any command is executed
 */
//--------------------------------------------------------
void Lakeshore_336::always_executed_hook()
{
	INFO_STREAM << "Lakeshore_336::always_executed_hook()  " << device_name << endl;
	/*----- PROTECTED REGION ID(Lakeshore_336::always_executed_hook) ENABLED START -----*/

	//	code always executed before all requests

	/*----- PROTECTED REGION END -----*/	//	Lakeshore_336::always_executed_hook
}



//--------------------------------------------------------
/**
 *	Method      : Lakeshore_336::read_attr_hardware()
 *	Description : Hardware acquisition for attributes.
 */
//--------------------------------------------------------
void Lakeshore_336::read_attr_hardware(vector<long> &attr_list)
{
	(void)attr_list;
	DEBUG_STREAM << "Lakeshore_336::read_attr_hardware(vector<long> &attr_list) entering... " << endl;
	/*----- PROTECTED REGION ID(Lakeshore_336::read_attr_hardware) ENABLED START -----*/

	//	Add your own code

	/*----- PROTECTED REGION END -----*/	//	Lakeshore_336::read_attr_hardware

}


//--------------------------------------------------------
/**
 *	Read inputA attribute
 *	Description: temperature in Kelvin for Input A
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar 
 */
//--------------------------------------------------------
void Lakeshore_336::read_inputA(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Lakeshore_336::read_inputA(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Lakeshore_336::read_inputA) ENABLED START -----*/

	std::string response;
      	write_read (READTEMPA, response);
	string::size_type found = response.find_first_of(",");
	if (found!=string::npos) {
		double_val = atof(response.substr(0, found).c_str());
	} else {
		double_val = atof(response.c_str());
	}	
	
	//	Set the attribute value
	attr.set_value(&double_val);

	/*----- PROTECTED REGION END -----*/	//	Lakeshore_336::read_inputA
}
//--------------------------------------------------------
/**
 *	Read inputB attribute
 *	Description: temperature in Kelvin for Input B
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar 
 */
//--------------------------------------------------------
void Lakeshore_336::read_inputB(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Lakeshore_336::read_inputB(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Lakeshore_336::read_inputB) ENABLED START -----*/

	std::string response;
      	write_read (READTEMPB, response);
	string::size_type found = response.find_first_of(",");
	if (found!=string::npos) {
		double_val = atof(response.substr(0, found).c_str());
	} else {
		double_val = atof(response.c_str());
	}	
	
	//	Set the attribute value
	attr.set_value(&double_val);

	/*----- PROTECTED REGION END -----*/	//	Lakeshore_336::read_inputB
}
//--------------------------------------------------------
/**
 *	Read inputC attribute
 *	Description: temperature in Kelvin for Input C
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar 
 */
//--------------------------------------------------------
void Lakeshore_336::read_inputC(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Lakeshore_336::read_inputC(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Lakeshore_336::read_inputC) ENABLED START -----*/
	std::string response;
      	write_read (READTEMPC, response);
	string::size_type found = response.find_first_of(",");
	if (found!=string::npos) {
		double_val = atof(response.substr(0, found).c_str());
	} else {
		double_val = atof(response.c_str());
	}	
	
	//	Set the attribute value
	attr.set_value(&double_val);

	/*----- PROTECTED REGION END -----*/	//	Lakeshore_336::read_inputC
}
//--------------------------------------------------------
/**
 *	Read inputD attribute
 *	Description: temperature in Kelvin for Input D
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar 
 */
//--------------------------------------------------------
void Lakeshore_336::read_inputD(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Lakeshore_336::read_inputD(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Lakeshore_336::read_inputD) ENABLED START -----*/
	std::string response;
      	write_read (READTEMPD, response);
	string::size_type found = response.find_first_of(",");
	if (found!=string::npos) {
		double_val = atof(response.substr(0, found).c_str());
	} else {
		double_val = atof(response.c_str());
	}	
	
	//	Set the attribute value
	attr.set_value(&double_val);

	/*----- PROTECTED REGION END -----*/	//	Lakeshore_336::read_inputD
}
//--------------------------------------------------------
/**
 *	Read SetP attribute
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar 
 */
//--------------------------------------------------------
void Lakeshore_336::read_SetP(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Lakeshore_336::read_SetP(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Lakeshore_336::read_SetP) ENABLED START -----*/
	std::string response;
      	write_read (READTEMPSETPOINT2, response);
	double_val = atof(response.c_str());

	//	Set the attribute value
	attr.set_value(&double_val);

	/*----- PROTECTED REGION END -----*/	//	Lakeshore_336::read_SetP
}

//--------------------------------------------------------
/**
 *	Write SetP attribute values to hardware.
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar 
 */
//--------------------------------------------------------
void Lakeshore_336::write_SetP(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Lakeshore_336::write_SetP(Tango::Attribute &attr) entering... " << endl;
	
	//	Retrieve write value
	Tango::DevDouble	w_val;
	attr.get_write_value(w_val);
	
	/*----- PROTECTED REGION ID(Lakeshore_336::write_SetP) ENABLED START -----*/
	stringstream w_val_text;
	string response;
	w_val_text << WRITETEMPSETPOINT2 << w_val;

	write (w_val_text.str());
	/*----- PROTECTED REGION END -----*/	//	Lakeshore_336::write_SetP
}

//--------------------------------------------------------
/**
 *	Read Heater attribute
 *	Description: 
 *
 *	Data type:	Tango::DevFloat
 *	Attr type:	Scalar 
 */
//--------------------------------------------------------
void Lakeshore_336::read_Heater(Tango::Attribute &attr) // TODO we have to test
{
	DEBUG_STREAM << "Lakeshore_336::read_Heater(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Lakeshore_336::read_Heater) ENABLED START -----*/
	std::string response;
      	write_read (READHEATEROUTPUT2, response);
	double_val = atof(response.c_str());

	//	Set the attribute value
	attr.set_value(&double_val);

	/*----- PROTECTED REGION END -----*/	//	Lakeshore_336::read_Heater
}

void Lakeshore_336::readPid(void) // TODO we have to test
{
	std::string response, val1, val2, val3;
	string::size_type found1, found2, found3;

	write_read (READPID2, response);
	if ((found1 = response.find(",")) != string::npos) {
		val1 = response.substr(0, found1);
		*attr_PidProportional_read = (float)atof(val1.c_str());
	}
	if ((found2 = response.find(",", found1)) != string::npos) {
		val2 = response.substr(found1, found2);
		*attr_PidIntegral_read = (float)atof(val2.c_str());
	}
	if ((found3 = response.find(",", found2)) != string::npos) {
		val3 = response.substr(found2, found3);
		*attr_PidDerivative_read = (unsigned char)atoi(val3.c_str());
	}
}

void Lakeshore_336::writePid(float prop, float inter, unsigned char der) // TODO we have to test
{
	stringstream w_val_text;
	w_val_text <<  WRITEPID2 << prop << "," << inter << "," << der;

	write (w_val_text.str());
}

//--------------------------------------------------------
/**
 *	Read PidProportional attribute
 *	Description: 
 *
 *	Data type:	Tango::DevFloat
 *	Attr type:	Scalar 
 */
//--------------------------------------------------------
void Lakeshore_336::read_PidProportional(Tango::Attribute &attr) // TODO we have to test
{
	DEBUG_STREAM << "Lakeshore_336::read_PidProportional(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Lakeshore_336::read_PidProportional) ENABLED START -----*/

	readPid();

	//	Set the attribute value
	attr.set_value(attr_PidProportional_read);

	/*----- PROTECTED REGION END -----*/	//	Lakeshore_336::read_PidProportional
}

//--------------------------------------------------------
/**
 *	Write PidProportional attribute values to hardware.
 *
 *	Data type:	Tango::DevFloat
 *	Attr type:	Scalar 
 */
//--------------------------------------------------------
void Lakeshore_336::write_PidProportional(Tango::WAttribute &attr) // TODO we have to test
{
	DEBUG_STREAM << "Lakeshore_336::write_PidProportional(Tango::Attribute &attr) entering... " << endl;
	
	//	Retrieve write value
	Tango::DevFloat	w_val;
	attr.get_write_value(w_val);
	
	/*----- PROTECTED REGION ID(Lakeshore_336::write_PidProportional) ENABLED START -----*/

	readPid();
	writePid(w_val, *attr_PidIntegral_read, *attr_PidDerivative_read);

	/*----- PROTECTED REGION END -----*/	//	Lakeshore_336::write_PidProportional
}

//--------------------------------------------------------
/**
 *	Read PidIntegral attribute
 *	Description: 
 *
 *	Data type:	Tango::DevFloat
 *	Attr type:	Scalar 
 */
//--------------------------------------------------------
void Lakeshore_336::read_PidIntegral(Tango::Attribute &attr) // TODO we have to test
{
	DEBUG_STREAM << "Lakeshore_336::read_PidIntegral(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Lakeshore_336::read_PidIntegral) ENABLED START -----*/

	readPid();

	//	Set the attribute value
	attr.set_value(attr_PidIntegral_read);

	/*----- PROTECTED REGION END -----*/	//	Lakeshore_336::read_PidIntegral
}

//--------------------------------------------------------
/**
 *	Write PidIntegral attribute values to hardware.
 *
 *	Data type:	Tango::DevFloat
 *	Attr type:	Scalar 
 */
//--------------------------------------------------------
void Lakeshore_336::write_PidIntegral(Tango::WAttribute &attr) // TODO we have to test
{
	DEBUG_STREAM << "Lakeshore_336::write_PidIntegral(Tango::Attribute &attr) entering... " << endl;
	
	//	Retrieve write value
	Tango::DevFloat	w_val;
	attr.get_write_value(w_val);
	
	/*----- PROTECTED REGION ID(Lakeshore_336::write_PidIntegral) ENABLED START -----*/

	readPid();
	writePid(*attr_PidProportional_read, w_val, *attr_PidDerivative_read);

	/*----- PROTECTED REGION END -----*/	//	Lakeshore_336::write_PidIntegral
}

//--------------------------------------------------------
/**
 *	Read PidDerivative attribute
 *	Description: 
 *
 *	Data type:	Tango::DevUChar
 *	Attr type:	Scalar 
 */
//--------------------------------------------------------
void Lakeshore_336::read_PidDerivative(Tango::Attribute &attr) // TODO we have to test
{
	DEBUG_STREAM << "Lakeshore_336::read_PidDerivative(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Lakeshore_336::read_PidDerivative) ENABLED START -----*/

	readPid();

	//	Set the attribute value
	attr.set_value(attr_PidDerivative_read);

	/*----- PROTECTED REGION END -----*/	//	Lakeshore_336::read_PidDerivative
}

//--------------------------------------------------------
/**
 *	Write PidDerivative attribute values to hardware.
 *
 *	Data type:	Tango::DevUChar
 *	Attr type:	Scalar 
 */
//--------------------------------------------------------
void Lakeshore_336::write_PidDerivative(Tango::WAttribute &attr) // TODO we have to test
{
	DEBUG_STREAM << "Lakeshore_336::write_PidDerivative(Tango::Attribute &attr) entering... " << endl;
	
	//	Retrieve write value
	Tango::DevUChar	w_val;
	attr.get_write_value(w_val);
	
	/*----- PROTECTED REGION ID(Lakeshore_336::write_PidDerivative) ENABLED START -----*/

	readPid();
	writePid(*attr_PidProportional_read, *attr_PidIntegral_read, w_val);

	/*----- PROTECTED REGION END -----*/	//	Lakeshore_336::write_PidDerivative
}


//--------------------------------------------------------
/**
 *	Method      : Lakeshore_336::Lakeshore_336Class::add_dynamic_attributes()
 *	Description : Create the dynamic attributes if any
 *	              for specified device.
 */
//--------------------------------------------------------
void Lakeshore_336::add_dynamic_attributes()
{
	/*----- PROTECTED REGION ID(Lakeshore_336::Class::add_dynamic_attributes) ENABLED START -----*/

	//	Add your own code to create and add dynamic attributes if any

	/*----- PROTECTED REGION END -----*/	//	Lakeshore_336::Class::add_dynamic_attributes

}



//========================================================
//	Command execution methods
//========================================================

//--------------------------------------------------------
/**
 *	Execute the State command:
 *	Description: This command gets the device state (stored in its <i>device_state</i> data member) and returns it to the caller.
 *
 *	@param argin none.
 *	@returns State Code
 */
//--------------------------------------------------------
Tango::DevState Lakeshore_336::dev_state()
{
	DEBUG_STREAM << "Lakeshore_336::State()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(Lakeshore_336::dev_state) ENABLED START -----*/

	Tango::DevState	argout = DeviceImpl::dev_state();
		//	Add your own state management

	/*----- PROTECTED REGION END -----*/	//	Lakeshore_336::dev_state

	set_state(argout);               // Give the state to Tango.
	return DeviceImpl::dev_state();  // Return it after Tango management.

}

//--------------------------------------------------------
/**
 *	Execute the Status command:
 *	Description: This command gets the device status (stored in its <i>device_status</i> data member) and returns it to the caller.
 *
 *	@param argin none.
 *	@returns Status description
 */
//--------------------------------------------------------
Tango::ConstDevString Lakeshore_336::dev_status()
{
	DEBUG_STREAM << "Lakeshore_336::Status()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(Lakeshore_336::dev_status) ENABLED START -----*/

	string	status = "Device connection: ";
		//	Add your own status management
	status += socket->status();
	
	set_status(status);

	/*----- PROTECTED REGION END -----*/	//	Lakeshore_336::dev_status

	set_status(status);               // Give the status to Tango.
	return DeviceImpl::dev_status();  // Return it.

}


	/*----- PROTECTED REGION ID(Lakeshore_336::namespace_ending) ENABLED START -----*/

	//	Additional Methods
//+----------------------------------------------------------------------------
//
// method : 		Lakeshore_336::write
// 
// description : 	Send a message string to the pilatus detector
//
//-----------------------------------------------------------------------------
void Lakeshore_336::write(std::string cmd_in)
{
	DEBUG_STREAM << "Lakeshore_336::write_read try to send command: " << cmd_in;
	Tango::DeviceData argin;

	cmd_in += "\n";
	argin << cmd_in ;
	
	socket->command_inout ("Write", argin);
}
//+----------------------------------------------------------------------------
//
// method : 		Lakeshore_336::write_read
// 
// description : 	Send a message string to the pilatus detector
//                  and get the answer message
//
//-----------------------------------------------------------------------------
void Lakeshore_336::write_read(std::string cmd_in, std::string & response)
{
	DEBUG_STREAM << "Lakeshore_336::write_read try to send command: " << cmd_in;
	Tango::DeviceData argin;
	Tango::DeviceData dd_out;
	
	response.clear ();

	cmd_in += "\n";
	argin << cmd_in;
	
	dd_out = socket->command_inout ("WriteAndRead", argin);
	dd_out >> response;

	string resp = response;
	resp.erase(remove(resp.begin(), resp.end(), '\n'), resp.end()); // TODO we have to test
	DEBUG_STREAM << "Lakeshore_336::write_read response received: " << resp;
}
	/*----- PROTECTED REGION END -----*/	//	Lakeshore_336::namespace_ending
} //	namespace
