/*----- PROTECTED REGION ID(Lakeshore_336.h) ENABLED START -----*/
//=============================================================================
//
// file :        Lakeshore_336.h
//
// description : Include for the Lakeshore_336 class.
//
// project :     Lakeshore_336.
//
// $Author: alessio $
//
// $Revision: 1.1.1.1 $
// $Date: 2014-02-25 10:01:39 $
//
// SVN only:
// $HeadURL:  $
//
// CVS only:
// $Source: /home/cvsadm/cvsroot/fermi/servers/336/src/Lakeshore_336.h,v $
// $Log: Lakeshore_336.h,v $
// Revision 1.1.1.1  2014-02-25 10:01:39  alessio
// Initial import
//
// Revision 1.1.1.1  2012-11-27 10:07:31  alessio
// Initial import
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef LAKESHORE_336_H
#define LAKESHORE_336_H


#include <tango.h>

/*----- PROTECTED REGION END -----*/


/**
 *	Lakeshore_336 class Description:
 *	basic interface for the Lakeshore Model 336 Temperature controller,
 *	GPIB/Ethernet interface.
 *	reads 4 temperatures, outputs, alarms.
 */

namespace Lakeshore_336_ns
{
	/*----- PROTECTED REGION ID(Lakeshore_336::Additional Class Declarations) ENABLED START -----*/

		//		Additional Class Declarations

	/*----- PROTECTED REGION END -----*/	//	Lakeshore_336::Additional Class Declarations


class Lakeshore_336 : public Tango::Device_4Impl
{


	/*----- PROTECTED REGION ID(Lakeshore_336::Data Members) ENABLED START -----*/

	//		Add your own data members

#define READTEMPA "KRDG? A"
#define READTEMPB "KRDG? B"
#define READTEMPC "KRDG? C"
#define READTEMPD "KRDG? D"
#define READTEMPSETPOINT1    "SETP? 1"
#define READTEMPSETPOINT2    "SETP? 2"
#define WRITETEMPSETPOINT1   "SETP 1,"
#define WRITETEMPSETPOINT2   "SETP 2,"
#define READHEATEROUTPUT1    "HTR? 1"
#define READHEATEROUTPUT2    "HTR? 2"
#define READPID1             "PID? 1"
#define READPID2             "PID? 2"
#define WRITEPID1             "PID 1,"
#define WRITEPID2             "PID 2,"
	/*----- PROTECTED REGION END -----*/	//	Lakeshore_336::Data Members


//	Device property data members
public:		//	SocketDeviceProxy:	the Tango name of the communication device proxy (Ethernet)
	string	socketDeviceProxy;
	

//	Attribute data members
public:
	Tango::DevDouble	*attr_inputA_read;
	Tango::DevDouble	*attr_inputB_read;
	Tango::DevDouble	*attr_inputC_read;
	Tango::DevDouble	*attr_inputD_read;
	Tango::DevDouble	*attr_SetP_read;
	Tango::DevFloat	*attr_Heater_read;
	Tango::DevFloat	*attr_PidProportional_read;
	Tango::DevFloat	*attr_PidIntegral_read;
	Tango::DevUChar	*attr_PidDerivative_read;



//	Constructors and destructors
public:
	/**
	 * Constructs a newly allocated Command object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device Name
	 */
	Lakeshore_336(Tango::DeviceClass *cl,string &s);
	/**
	 * Constructs a newly allocated Command object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device Name
	 */
	Lakeshore_336(Tango::DeviceClass *cl,const char *s);
	/**
	 * Constructs a newly allocated Command object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device name
	 *	@param d	Device description.
	 */
	Lakeshore_336(Tango::DeviceClass *cl,const char *s,const char *d);
	/**
	 * The object destructor.
	 */	
	~Lakeshore_336() {delete_device();};



//	Miscellaneous methods
public:
	/**
	 *	will be called at device destruction or at init command.
	 */
	void delete_device();
	/**
	 *	Initialize the device
	 */
	virtual void init_device();
	/**
	 *	Read the device properties from database
	 */
	 void get_device_property();
	/**
	 *	Always executed method before execution command method.
	 */
	virtual void always_executed_hook();


//	Attribute methods
public:
	/**
	 *	Method      : Lakeshore_336::read_attr_hardware()
	 *	Description : Hardware acquisition for attributes.
	 */
	virtual void read_attr_hardware(vector<long> &attr_list);


	/**
	 *	inputA attribute related methods.
	 *	Description: temperature in Kelvin for Input A
	 *
	 *	Data type:	Tango::DevDouble
	 *	Attr type:	Scalar 
	 */
	virtual void read_inputA(Tango::Attribute &attr);
	virtual bool is_inputA_allowed(Tango::AttReqType type);



	/**
	 *	inputB attribute related methods.
	 *	Description: temperature in Kelvin for Input B
	 *
	 *	Data type:	Tango::DevDouble
	 *	Attr type:	Scalar 
	 */
	virtual void read_inputB(Tango::Attribute &attr);
	virtual bool is_inputB_allowed(Tango::AttReqType type);



	/**
	 *	inputC attribute related methods.
	 *	Description: temperature in Kelvin for Input C
	 *
	 *	Data type:	Tango::DevDouble
	 *	Attr type:	Scalar 
	 */
	virtual void read_inputC(Tango::Attribute &attr);
	virtual bool is_inputC_allowed(Tango::AttReqType type);



	/**
	 *	inputD attribute related methods.
	 *	Description: temperature in Kelvin for Input D
	 *
	 *	Data type:	Tango::DevDouble
	 *	Attr type:	Scalar 
	 */
	virtual void read_inputD(Tango::Attribute &attr);
	virtual bool is_inputD_allowed(Tango::AttReqType type);



	/**
	 *	SetP attribute related methods.
	 *	Description: 
	 *
	 *	Data type:	Tango::DevDouble
	 *	Attr type:	Scalar 
	 */
	virtual void read_SetP(Tango::Attribute &attr);
	virtual void write_SetP(Tango::WAttribute &attr);
	virtual bool is_SetP_allowed(Tango::AttReqType type);



	/**
	 *	Heater attribute related methods.
	 *	Description: 
	 *
	 *	Data type:	Tango::DevFloat
	 *	Attr type:	Scalar 
	 */
	virtual void read_Heater(Tango::Attribute &attr);
	virtual bool is_Heater_allowed(Tango::AttReqType type);



	/**
	 *	PidProportional attribute related methods.
	 *	Description: 
	 *
	 *	Data type:	Tango::DevFloat
	 *	Attr type:	Scalar 
	 */
	virtual void read_PidProportional(Tango::Attribute &attr);
	virtual void write_PidProportional(Tango::WAttribute &attr);
	virtual bool is_PidProportional_allowed(Tango::AttReqType type);



	/**
	 *	PidIntegral attribute related methods.
	 *	Description: 
	 *
	 *	Data type:	Tango::DevFloat
	 *	Attr type:	Scalar 
	 */
	virtual void read_PidIntegral(Tango::Attribute &attr);
	virtual void write_PidIntegral(Tango::WAttribute &attr);
	virtual bool is_PidIntegral_allowed(Tango::AttReqType type);



	/**
	 *	PidDerivative attribute related methods.
	 *	Description: 
	 *
	 *	Data type:	Tango::DevUChar
	 *	Attr type:	Scalar 
	 */
	virtual void read_PidDerivative(Tango::Attribute &attr);
	virtual void write_PidDerivative(Tango::WAttribute &attr);
	virtual bool is_PidDerivative_allowed(Tango::AttReqType type);



	/**
	 *	Method      : Lakeshore_336::add_dynamic_attributes()
	 *	Description : Add dynamic attributes if any.
	 */
		void add_dynamic_attributes();

//	Command related methods
public: 
	/**
	 *	Command State related methods.
	 */
	Tango::DevState dev_state();

	/**
	 *	Command Status related methods.
	 */
	Tango::ConstDevString dev_status();



	/*----- PROTECTED REGION ID(Lakeshore_336::Additional Method prototypes) ENABLED START -----*/

	//	Additional Method prototypes
	Tango::DeviceProxy *socket;
	Tango::DevDouble double_val;
	
	void write(std::string cmd);
	void write_read(std::string cmd, std::string & response);

	void readPid(void);
	void writePid(float, float, unsigned char);

	/*----- PROTECTED REGION END -----*/	//	Lakeshore_336::Additional Method prototypes

};

	/*----- PROTECTED REGION ID(Lakeshore_336::Additional Classes Definitions) ENABLED START -----*/

	//	Additional Classes definitions
	

	/*----- PROTECTED REGION END -----*/	//	Lakeshore_336::Additional Classes Definitions

} //	namespace

#endif	//	LAKESHORE_336_H
