/*----- PROTECTED REGION ID(Lakeshore_336Class.cpp) ENABLED START -----*/
static const char *TagName    = "$Name:  $";
static const char *CvsPath    = "$Source: /home/cvsadm/cvsroot/fermi/servers/336/src/Lakeshore_336Class.cpp,v $";
static const char *SvnPath    = "$HeadURL:  $";
static const char *HttpServer = "http://www.esrf.eu/computing/cs/tango/tango_doc/ds_doc/";
//=============================================================================
//
// file :        Lakeshore_336Class.cpp
//
// description : C++ source for the Lakeshore_336Class. A singleton
//               class derived from DeviceClass. It implements the
//               command list and all properties and methods required
//               by the name once per process.
//
// project :     Lakeshore_336.
//
// $Author: alessio $
//
// $Revision: 1.1.1.1 $
// $Date: 2014-02-25 10:01:39 $
//
// SVN only:
// $HeadURL:  $
//
// CVS only:
// $Source: /home/cvsadm/cvsroot/fermi/servers/336/src/Lakeshore_336Class.cpp,v $
// $Log: Lakeshore_336Class.cpp,v $
// Revision 1.1.1.1  2014-02-25 10:01:39  alessio
// Initial import
//
// Revision 1.2  2013-05-30 13:29:00  alessio
// Move to Tango8 and remove all build warnings
//
// Revision 1.1.1.1  2012-11-27 10:07:31  alessio
// Initial import
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#include <Lakeshore_336Class.h>

/*----- PROTECTED REGION END -----*/

//-------------------------------------------------------------------
/**
 *	Create Lakeshore_336Class singleton and
 *	return it in a C function for Python usage
 */
//-------------------------------------------------------------------
extern "C" {
#ifdef _TG_WINDOWS_

__declspec(dllexport)

#endif

	Tango::DeviceClass *_create_Lakeshore_336_class(const char *name) {
		return Lakeshore_336_ns::Lakeshore_336Class::init(name);
	}
}


namespace Lakeshore_336_ns
{


//===================================================================
//	Initialize pointer for singleton pattern
//===================================================================
Lakeshore_336Class *Lakeshore_336Class::_instance = NULL;

//--------------------------------------------------------
/**
 * method : 		Lakeshore_336Class::Lakeshore_336Class(string &s)
 * description : 	constructor for the Lakeshore_336Class
 *
 * @param s	The class name
 */
//--------------------------------------------------------
Lakeshore_336Class::Lakeshore_336Class(string &s):DeviceClass(s)
{
	cout2 << "Entering Lakeshore_336Class constructor" << endl;
	set_default_property();
	get_class_property();
	write_class_property();

	/*----- PROTECTED REGION ID(Lakeshore_336::Class::constructor) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	Lakeshore_336::Class::constructor

	cout2 << "Leaving Lakeshore_336Class constructor" << endl;
}


//--------------------------------------------------------
/**
 * method : 		Lakeshore_336Class::~Lakeshore_336Class()
 * description : 	destructor for the Lakeshore_336Class
 */
//--------------------------------------------------------
Lakeshore_336Class::~Lakeshore_336Class()
{
	/*----- PROTECTED REGION ID(Lakeshore_336::Class::destructor) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	Lakeshore_336::Class::destructor

	_instance = NULL;
}


//--------------------------------------------------------
/**
 * method : 		Lakeshore_336Class::init
 * description : 	Create the object if not already done.
 *                  Otherwise, just return a pointer to the object
 *
 * @param	name	The class name
 */
//--------------------------------------------------------
Lakeshore_336Class *Lakeshore_336Class::init(const char *name)
{
	if (_instance == NULL)
	{
		try
		{
			string s(name);
			_instance = new Lakeshore_336Class(s);
		}
		catch (bad_alloc)
		{
			throw;
		}		
	}		
	return _instance;
}

//--------------------------------------------------------
/**
 * method : 		Lakeshore_336Class::instance
 * description : 	Check if object already created,
 *                  and return a pointer to the object
 */
//--------------------------------------------------------
Lakeshore_336Class *Lakeshore_336Class::instance()
{
	if (_instance == NULL)
	{
		cerr << "Class is not initialised !!" << endl;
		exit(-1);
	}
	return _instance;
}




//===================================================================
//	Command execution method calls
//===================================================================




//===================================================================
//	Properties management
//===================================================================

//--------------------------------------------------------
/**
 * method : 		Lakeshore_336Class::get_class_property
 * description : 	Get the class property for specified name.
 *
 * @param	name  The property name
 */
//--------------------------------------------------------
Tango::DbDatum Lakeshore_336Class::get_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_prop.size() ; i++)
		if (cl_prop[i].name == prop_name)
			return cl_prop[i];
	//	if not found, returns  an empty DbDatum
	return Tango::DbDatum(prop_name);
}


//--------------------------------------------------------
/**
 *	Method      : Lakeshore_336::Lakeshore_336Class::get_default_device_property()()
 *	Description : Return the default value for device property.
 */
//--------------------------------------------------------
Tango::DbDatum Lakeshore_336Class::get_default_device_property(string &prop_name)
{
	for (unsigned int i=0 ; i<dev_def_prop.size() ; i++)
		if (dev_def_prop[i].name == prop_name)
			return dev_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}


//--------------------------------------------------------
/**
 *	Method      : Lakeshore_336::Lakeshore_336Class::get_default_class_property()()
 *	Description : Return the default value for class property.
 */
//--------------------------------------------------------
Tango::DbDatum Lakeshore_336Class::get_default_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_def_prop.size() ; i++)
		if (cl_def_prop[i].name == prop_name)
			return cl_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}


//--------------------------------------------------------
/**
 *	Method      : Lakeshore_336::Lakeshore_336Class::get_class_property()
 *	Description : //	Add your own code to initialize
 */
//--------------------------------------------------------
void Lakeshore_336Class::get_class_property()
{
}


//--------------------------------------------------------
/**
 *	Method      : Lakeshore_336::Lakeshore_336Class::set_default_property()
 *	Description : Set default property (class and device) for wizard.
 *	              For each property, add to wizard property name and description.
 *	              If default value has been set, add it to wizard property and.
 *	              store it in a DbDatum.
 */
//--------------------------------------------------------
void Lakeshore_336Class::set_default_property()
{
	string	prop_name;
	string	prop_desc;
	string	prop_def;
	vector<string>	vect_data;
	
	//	Set Default Class Properties

	//	Set Default Device Properties

	prop_name = "SocketDeviceProxy";
	prop_desc = "the Tango name of the communication device proxy (Ethernet)";
	prop_def  = "dev/comm/socket\n";
	vect_data.clear();
	vect_data.push_back("dev/comm/socket");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
}


//--------------------------------------------------------
/**
 *	Method      : Lakeshore_336::Lakeshore_336Class::write_class_property()
 *	Description : Set class description fields as property in database
 */
//--------------------------------------------------------
void Lakeshore_336Class::write_class_property()
{
	//	First time, check if database used
	if (Tango::Util::_UseDb == false)
		return;

	Tango::DbData	data;
	string	classname = get_name();
	string	header;
	string::size_type	start, end;

	//	Put title
	Tango::DbDatum	title("ProjectTitle");
	string	str_title("Lakeshore_336");
	title << str_title;
	data.push_back(title);

	//	Put Description
	Tango::DbDatum	description("Description");
	vector<string>	str_desc;
	str_desc.push_back("basic interface for the Lakeshore Model 336 Temperature controller,");
	str_desc.push_back("GPIB/Ethernet interface.");
	str_desc.push_back("reads 4 temperatures, outputs, alarms.");
	description << str_desc;
	data.push_back(description);
		
	//	put cvs or svn location
	string	filename("Lakeshore_336");
	filename += "Class.cpp";
	
	// check for cvs information
	string	src_path(CvsPath);
	start = src_path.find("/");
	if (start!=string::npos)
	{
		end   = src_path.find(filename);
		if (end>start)
		{
			string	strloc = src_path.substr(start, end-start);
			//	Check if specific repository
			start = strloc.find("/cvsroot/");
			if (start!=string::npos && start>0)
			{
				string	repository = strloc.substr(0, start);
				if (repository.find("/segfs/")!=string::npos)
					strloc = "ESRF:" + strloc.substr(start, strloc.length()-start);
			}
			Tango::DbDatum	cvs_loc("cvs_location");
			cvs_loc << strloc;
			data.push_back(cvs_loc);
		}
	}
	// check for svn information
	else
	{
		string	src_path(SvnPath);
		start = src_path.find("://");
		if (start!=string::npos)
		{
			end = src_path.find(filename);
			if (end>start)
			{
				header = "$HeadURL: ";
				start = header.length();
				string	strloc = src_path.substr(start, (end-start));
				
				Tango::DbDatum	svn_loc("svn_location");
				svn_loc << strloc;
				data.push_back(svn_loc);
			}
		}
	}

	//	Get CVS or SVN revision tag
	
	// CVS tag
	string	tagname(TagName);
	header = "$Name: ";
	start = header.length();
	string	endstr(" $");
	
	end   = tagname.find(endstr);
	if (end!=string::npos && end>start)
	{
		string	strtag = tagname.substr(start, end-start);
		Tango::DbDatum	cvs_tag("cvs_tag");
		cvs_tag << strtag;
		data.push_back(cvs_tag);
	}
	
	// SVN tag
	string	svnpath(SvnPath);
	header = "$HeadURL: ";
	start = header.length();
	
	end   = svnpath.find(endstr);
	if (end!=string::npos && end>start)
	{
		string	strloc = svnpath.substr(start, end-start);
		
		string tagstr ("/tags/");
		start = strloc.find(tagstr);
		if ( start!=string::npos )
		{
			start = start + tagstr.length();
			end   = strloc.find(filename);
			string	strtag = strloc.substr(start, end-start-1);
			
			Tango::DbDatum	svn_tag("svn_tag");
			svn_tag << strtag;
			data.push_back(svn_tag);
		}
	}

	//	Get URL location
	string	httpServ(HttpServer);
	if (httpServ.length()>0)
	{
		Tango::DbDatum	db_doc_url("doc_url");
		db_doc_url << httpServ;
		data.push_back(db_doc_url);
	}

	//  Put inheritance
	Tango::DbDatum	inher_datum("InheritedFrom");
	vector<string> inheritance;
	inheritance.push_back("Device_4Impl");
	inher_datum << inheritance;
	data.push_back(inher_datum);

	//	Call database and and values
	get_db_class()->put_property(data);
}




//===================================================================
//	Factory methods
//===================================================================


//--------------------------------------------------------
/**
 * method : 		Lakeshore_336Class::device_factory
 * description : 	Create the device object(s)
 *                  and store them in the device list
 *
 * @param	*devlist_ptr	The device name list
 */
//--------------------------------------------------------
void Lakeshore_336Class::device_factory(const Tango::DevVarStringArray *devlist_ptr)
{

	/*----- PROTECTED REGION ID(Lakeshore_336::Class::device_factory_before) ENABLED START -----*/

	//	Add your own code

	/*----- PROTECTED REGION END -----*/	//	Lakeshore_336::Class::device_factory_before

	//	Create devices and add it into the device list
	for (unsigned long i=0 ; i<devlist_ptr->length() ; i++)
	{
		cout4 << "Device name : " << (*devlist_ptr)[i].in() << endl;
		device_list.push_back(new Lakeshore_336(this, (*devlist_ptr)[i]));							 
	}

	//	Manage dynamic attributes if any
	erase_dynamic_attributes(devlist_ptr, get_class_attr()->get_attr_list());

	//	Export devices to the outside world
	for (unsigned long i=1 ; i<=devlist_ptr->length() ; i++)
	{
		//	Add dynamic attributes if any
		Lakeshore_336 *dev = static_cast<Lakeshore_336 *>(device_list[device_list.size()-i]);
		dev->add_dynamic_attributes();

		//	Check before if database used.
		if ((Tango::Util::_UseDb == true) && (Tango::Util::_FileDb == false))
			export_device(dev);
		else
			export_device(dev, dev->get_name().c_str());
	}

	/*----- PROTECTED REGION ID(Lakeshore_336::Class::device_factory_after) ENABLED START -----*/

	//	Add your own code

	/*----- PROTECTED REGION END -----*/	//	Lakeshore_336::Class::device_factory_after

	
}


//--------------------------------------------------------
/**
 *	Method      : Lakeshore_336::Lakeshore_336Class::attribute_factory()
 *	Description : Create the attribute object(s)
 *	              and store them in the attribute list
 */
//--------------------------------------------------------
void Lakeshore_336Class::attribute_factory(vector<Tango::Attr *> &att_list)
{
	/*----- PROTECTED REGION ID(Lakeshore_336::Class::attribute_factory_before) ENABLED START -----*/

	//	Add your own code

	/*----- PROTECTED REGION END -----*/	//	Lakeshore_336::Class::attribute_factory_before


	//	Attribute : inputA
	inputAAttrib	*inputa = new inputAAttrib();
	Tango::UserDefaultAttrProp	inputa_prop;
	inputa_prop.set_description("temperature in Kelvin for Input A");
	inputa_prop.set_label("input A");
	inputa_prop.set_unit("K");
	inputa_prop.set_standard_unit("K");
	inputa_prop.set_display_unit("�K");
	inputa_prop.set_format("%4.1f");
	//	max_value	not set for	inputA
	//	min_value	not set for	inputA
	//	max_alarm	not set for	inputA
	//	min_alarm	not set for	inputA
	//	max_warning	not set for	inputA
	//	min_warning	not set for	inputA
	//	delta_t	not set for	inputA
	//	delta_val	not set for	inputA
	inputa->set_default_properties(inputa_prop);
	//	Not Polled
	inputa->set_disp_level(Tango::OPERATOR);
	//	Not memorized

	//	inputA does not fire change event
	//	inputA does not fire archive event
	//	inputA does not fire data_ready event
	att_list.push_back(inputa);

	//	Attribute : inputB
	inputBAttrib	*inputb = new inputBAttrib();
	Tango::UserDefaultAttrProp	inputb_prop;
	inputb_prop.set_description("temperature in Kelvin for Input B");
	inputb_prop.set_label("input B");
	inputb_prop.set_unit("K");
	inputb_prop.set_standard_unit("K");
	inputb_prop.set_display_unit("�K");
	inputb_prop.set_format("%4.1f");
	//	max_value	not set for	inputB
	//	min_value	not set for	inputB
	//	max_alarm	not set for	inputB
	//	min_alarm	not set for	inputB
	//	max_warning	not set for	inputB
	//	min_warning	not set for	inputB
	//	delta_t	not set for	inputB
	//	delta_val	not set for	inputB
	inputb->set_default_properties(inputb_prop);
	//	Not Polled
	inputb->set_disp_level(Tango::OPERATOR);
	//	Not memorized

	//	inputB does not fire change event
	//	inputB does not fire archive event
	//	inputB does not fire data_ready event
	att_list.push_back(inputb);

	//	Attribute : inputC
	inputCAttrib	*inputc = new inputCAttrib();
	Tango::UserDefaultAttrProp	inputc_prop;
	inputc_prop.set_description("temperature in Kelvin for Input C");
	inputc_prop.set_label("input C");
	inputc_prop.set_unit("K");
	inputc_prop.set_standard_unit("K");
	inputc_prop.set_display_unit("�K");
	inputc_prop.set_format("%4.1f");
	//	max_value	not set for	inputC
	//	min_value	not set for	inputC
	//	max_alarm	not set for	inputC
	//	min_alarm	not set for	inputC
	//	max_warning	not set for	inputC
	//	min_warning	not set for	inputC
	//	delta_t	not set for	inputC
	//	delta_val	not set for	inputC
	inputc->set_default_properties(inputc_prop);
	//	Not Polled
	inputc->set_disp_level(Tango::OPERATOR);
	//	Not memorized

	//	inputC does not fire change event
	//	inputC does not fire archive event
	//	inputC does not fire data_ready event
	att_list.push_back(inputc);

	//	Attribute : inputD
	inputDAttrib	*inputd = new inputDAttrib();
	Tango::UserDefaultAttrProp	inputd_prop;
	inputd_prop.set_description("temperature in Kelvin for Input D");
	inputd_prop.set_label("input D");
	inputd_prop.set_unit("K");
	inputd_prop.set_standard_unit("K");
	inputd_prop.set_display_unit("�K");
	inputd_prop.set_format("%4.1f");
	//	max_value	not set for	inputD
	//	min_value	not set for	inputD
	//	max_alarm	not set for	inputD
	//	min_alarm	not set for	inputD
	//	max_warning	not set for	inputD
	//	min_warning	not set for	inputD
	//	delta_t	not set for	inputD
	//	delta_val	not set for	inputD
	inputd->set_default_properties(inputd_prop);
	//	Not Polled
	inputd->set_disp_level(Tango::OPERATOR);
	//	Not memorized

	//	inputD does not fire change event
	//	inputD does not fire archive event
	//	inputD does not fire data_ready event
	att_list.push_back(inputd);

	//	Attribute : SetP
	SetPAttrib	*setp = new SetPAttrib();
	Tango::UserDefaultAttrProp	setp_prop;
	//	description	not set for	SetP
	//	label	not set for	SetP
	//	unit	not set for	SetP
	//	standard_unit	not set for	SetP
	//	display_unit	not set for	SetP
	//	format	not set for	SetP
	//	max_value	not set for	SetP
	//	min_value	not set for	SetP
	//	max_alarm	not set for	SetP
	//	min_alarm	not set for	SetP
	//	max_warning	not set for	SetP
	//	min_warning	not set for	SetP
	//	delta_t	not set for	SetP
	//	delta_val	not set for	SetP
	setp->set_default_properties(setp_prop);
	//	Not Polled
	setp->set_disp_level(Tango::OPERATOR);
	//	Not memorized

	//	SetP does not fire change event
	//	SetP does not fire archive event
	//	SetP does not fire data_ready event
	att_list.push_back(setp);

	//	Attribute : Heater
	HeaterAttrib	*heater = new HeaterAttrib();
	Tango::UserDefaultAttrProp	heater_prop;
	//	description	not set for	Heater
	//	label	not set for	Heater
	//	unit	not set for	Heater
	//	standard_unit	not set for	Heater
	//	display_unit	not set for	Heater
	//	format	not set for	Heater
	//	max_value	not set for	Heater
	//	min_value	not set for	Heater
	//	max_alarm	not set for	Heater
	//	min_alarm	not set for	Heater
	//	max_warning	not set for	Heater
	//	min_warning	not set for	Heater
	//	delta_t	not set for	Heater
	//	delta_val	not set for	Heater
	heater->set_default_properties(heater_prop);
	//	Not Polled
	heater->set_disp_level(Tango::OPERATOR);
	//	Not memorized

	//	Heater does not fire change event
	//	Heater does not fire archive event
	//	Heater does not fire data_ready event
	att_list.push_back(heater);

	//	Attribute : PidProportional
	PidProportionalAttrib	*pidproportional = new PidProportionalAttrib();
	Tango::UserDefaultAttrProp	pidproportional_prop;
	//	description	not set for	PidProportional
	//	label	not set for	PidProportional
	//	unit	not set for	PidProportional
	//	standard_unit	not set for	PidProportional
	//	display_unit	not set for	PidProportional
	//	format	not set for	PidProportional
	//	max_value	not set for	PidProportional
	//	min_value	not set for	PidProportional
	//	max_alarm	not set for	PidProportional
	//	min_alarm	not set for	PidProportional
	//	max_warning	not set for	PidProportional
	//	min_warning	not set for	PidProportional
	//	delta_t	not set for	PidProportional
	//	delta_val	not set for	PidProportional
	pidproportional->set_default_properties(pidproportional_prop);
	//	Not Polled
	pidproportional->set_disp_level(Tango::OPERATOR);
	//	Not memorized

	//	PidProportional does not fire change event
	//	PidProportional does not fire archive event
	//	PidProportional does not fire data_ready event
	att_list.push_back(pidproportional);

	//	Attribute : PidIntegral
	PidIntegralAttrib	*pidintegral = new PidIntegralAttrib();
	Tango::UserDefaultAttrProp	pidintegral_prop;
	//	description	not set for	PidIntegral
	//	label	not set for	PidIntegral
	//	unit	not set for	PidIntegral
	//	standard_unit	not set for	PidIntegral
	//	display_unit	not set for	PidIntegral
	//	format	not set for	PidIntegral
	//	max_value	not set for	PidIntegral
	//	min_value	not set for	PidIntegral
	//	max_alarm	not set for	PidIntegral
	//	min_alarm	not set for	PidIntegral
	//	max_warning	not set for	PidIntegral
	//	min_warning	not set for	PidIntegral
	//	delta_t	not set for	PidIntegral
	//	delta_val	not set for	PidIntegral
	pidintegral->set_default_properties(pidintegral_prop);
	//	Not Polled
	pidintegral->set_disp_level(Tango::OPERATOR);
	//	Not memorized

	//	PidIntegral does not fire change event
	//	PidIntegral does not fire archive event
	//	PidIntegral does not fire data_ready event
	att_list.push_back(pidintegral);

	//	Attribute : PidDerivative
	PidDerivativeAttrib	*pidderivative = new PidDerivativeAttrib();
	Tango::UserDefaultAttrProp	pidderivative_prop;
	//	description	not set for	PidDerivative
	//	label	not set for	PidDerivative
	//	unit	not set for	PidDerivative
	//	standard_unit	not set for	PidDerivative
	//	display_unit	not set for	PidDerivative
	//	format	not set for	PidDerivative
	//	max_value	not set for	PidDerivative
	//	min_value	not set for	PidDerivative
	//	max_alarm	not set for	PidDerivative
	//	min_alarm	not set for	PidDerivative
	//	max_warning	not set for	PidDerivative
	//	min_warning	not set for	PidDerivative
	//	delta_t	not set for	PidDerivative
	//	delta_val	not set for	PidDerivative
	pidderivative->set_default_properties(pidderivative_prop);
	//	Not Polled
	pidderivative->set_disp_level(Tango::OPERATOR);
	//	Not memorized

	//	PidDerivative does not fire change event
	//	PidDerivative does not fire archive event
	//	PidDerivative does not fire data_ready event
	att_list.push_back(pidderivative);


	//	Create a list of static attributes
	create_static_attribute_list(get_class_attr()->get_attr_list());

	/*----- PROTECTED REGION ID(Lakeshore_336::Class::attribute_factory_after) ENABLED START -----*/

	//	Add your own code

	/*----- PROTECTED REGION END -----*/	//	Lakeshore_336::Class::attribute_factory_after

}


//--------------------------------------------------------
/**
 *	Method      : Lakeshore_336::Lakeshore_336Class::command_factory()
 *	Description : Create the command object(s)
 *	              and store them in the command list
 */
//--------------------------------------------------------
void Lakeshore_336Class::command_factory()
{
	/*----- PROTECTED REGION ID(Lakeshore_336::Class::command_factory_before) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	Lakeshore_336::Class::command_factory_before


	/*----- PROTECTED REGION ID(Lakeshore_336::Class::command_factory_after) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	Lakeshore_336::Class::command_factory_after

}




//===================================================================
//	Dynamic attributes related methods
//===================================================================


//--------------------------------------------------------
/**
 * method : 		Lakeshore_336Class::create_static_attribute_list
 * description : 	Create the a list of static attributes
 *
 * @param	att_list	the ceated attribute list 
 */
//--------------------------------------------------------
void Lakeshore_336Class::create_static_attribute_list(vector<Tango::Attr *> &att_list)
{
	for (unsigned long i=0 ; i<att_list.size() ; i++)
	{
		string att_name(att_list[i]->get_name());
		transform(att_name.begin(), att_name.end(), att_name.begin(), ::tolower);
		defaultAttList.push_back(att_name);
	}

	cout2 << defaultAttList.size() << " attributes in default list" << endl;


	/*----- PROTECTED REGION ID(Lakeshore_336::Class::create_static_att_list) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	Lakeshore_336::Class::create_static_att_list

}


//--------------------------------------------------------
/**
 * method : 		Lakeshore_336Class::erase_dynamic_attributes
 * description : 	delete the dynamic attributes if any.
 *
 * @param	devlist_ptr	the device list pointer
 * @param	list of all attributes
 */
//--------------------------------------------------------
void Lakeshore_336Class::erase_dynamic_attributes(const Tango::DevVarStringArray *devlist_ptr, vector<Tango::Attr *> &att_list)
{
	Tango::Util *tg = Tango::Util::instance();

	for (unsigned long i=0 ; i<devlist_ptr->length() ; i++)
	{	
		Tango::DeviceImpl *dev_impl = tg->get_device_by_name(((string)(*devlist_ptr)[i]).c_str());
		Lakeshore_336 *dev = static_cast<Lakeshore_336 *> (dev_impl);
		
		vector<Tango::Attribute *> &dev_att_list = dev->get_device_attr()->get_attribute_list();
		vector<Tango::Attribute *>::iterator ite_att;
		for (ite_att=dev_att_list.begin() ; ite_att != dev_att_list.end() ; ++ite_att)
		{
			string att_name((*ite_att)->get_name_lower());
			if ((att_name == "state") || (att_name == "status"))
				continue;
			vector<string>::iterator ite_str = find(defaultAttList.begin(), defaultAttList.end(), att_name);
			if (ite_str == defaultAttList.end())
			{
				cout2 << att_name << " is a UNWANTED dynamic attribute for device " << (*devlist_ptr)[i] << endl;
				Tango::Attribute &att = dev->get_device_attr()->get_attr_by_name(att_name.c_str());
				dev->remove_attribute(att_list[att.get_attr_idx()],true);
				--ite_att;
			}
		}
	}
	/*----- PROTECTED REGION ID(Lakeshore_336::Class::erase_dynamic_attributes) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	Lakeshore_336::Class::erase_dynamic_attributes

}



	/*----- PROTECTED REGION ID(Lakeshore_336::Class::Additional Methods) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	Lakeshore_336::Class::Additional Methods

} //	namespace
