/*PROTECTED REGION ID(Lakeshore_336::main.cpp) ENABLED START*/
//=============================================================================
//
// file :        Lakeshore_336.cpp
//
// description : C++ source for the Lakeshore_336 device server main.
//               The main rule is to initialise (and create) the Tango
//               system and to create the DServerClass singleton.
//                The main should be the same for every Tango device server.
//
// project :     Lakeshore_336.
//
// $Author: alessio $
//
// $Revision: 1.1.1.1 $
// $Date: 2014-02-25 10:01:39 $
//
// SVN only:
// $HeadURL:  $
//
// CVS only:
// $Source: /home/cvsadm/cvsroot/fermi/servers/336/src/main.cpp,v $
// $Log: main.cpp,v $
// Revision 1.1.1.1  2014-02-25 10:01:39  alessio
// Initial import
//
// Revision 1.2  2013-05-30 13:29:00  alessio
// Move to Tango8 and remove all build warnings
//
// Revision 1.1.1.1  2012-11-27 10:07:31  alessio
// Initial import
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================

#include <tango.h>


int main(int argc,char *argv[])
{
	Tango::Util *tg = NULL;
	try
	{
		// Initialise the device server
		//----------------------------------------
		tg = Tango::Util::init(argc,argv);

		// Create the device server singleton 
		//	which will create everything
		//----------------------------------------
		tg->server_init(false);

		// Run the endless loop
		//----------------------------------------
		cout << "Ready to accept request" << endl;
		tg->server_run();
	}
	catch (bad_alloc)
	{
		cout << "Can't allocate memory to store device object !!!" << endl;
		cout << "Exiting" << endl;
	}
	catch (CORBA::Exception &e)
	{
		Tango::Except::print_exception(e);
		
		cout << "Received a CORBA_Exception" << endl;
		cout << "Exiting" << endl;
	}
	if (tg!=NULL)
		tg->server_cleanup();
	return(0);
}
/*PROTECTED REGION END*/
//========================================================
